<script lang="ts">
import Vue from 'vue';
import DemoCard from './demo-card.vue';
import SeriesHeader from './series-header.vue';
import { isPastDate } from '~/lib/isPastDate';

export default Vue.extend({
  name: 'UpcomingDemoSeries',
  components: { DemoCard, SeriesHeader },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      regions: ['All regions', 'EMEA', 'AMER', 'APAC'],
      selectedRegion: 'All regions',
    };
  },
  computed: {
    allFutureEvents() {
      return this.data.card.filter(
        (entry) => !isPastDate(entry?.fields?.subtitle),
      );
    },
    filteredEvents() {
      if (this.selectedRegion !== 'All regions') {
        return this.allFutureEvents.filter((event) => {
          // If multiple regions are specified in CMS, filter event on them all
          if (event?.fields?.customFields?.regions) {
            return event?.fields?.customFields?.regions.some((reg) =>
              reg.includes(this.selectedRegion),
            );
          }

          // If only one region is specified in CMS, only filter by that region
          return event?.fields?.customFields?.region === this.selectedRegion;
        });
      }

      return this.allFutureEvents;
    },
  },
  methods: {
    selectRegion(region: string) {
      this.selectedRegion = region;
    },
  },
});
</script>

<template>
  <SlpContainer :class="data.class">
    <!-- When active-filter is true, SeriesHeader component receives options and selected option binding -->
    <SeriesHeader
      :header="data.header"
      :active-filter="data.activeFilter"
      :filter-options="regions"
      :selected="selectedRegion"
      @update:selected="selectRegion"
    >
      <DemoCard
        v-for="entry in filteredEvents"
        :key="entry.fields.title"
        :title="entry.fields.title"
        :date="entry.fields.subtitle"
        :is-disabled="entry.fields.button.fields.disabled"
        :button="entry.fields.button.fields"
      />
      <div v-if="filteredEvents.length === 0" class="slp-mt-16">
        {{ data.filterEmptyText }}
      </div>
    </SeriesHeader>
  </SlpContainer>
</template>
